unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, StdCtrls,
  Controls, Forms, Dialogs, RVStyle, RVScroll, RichView, RVEdit, RVTable, RVItem,
  RVTypes;

const
  WM_HIGHLIGHTCELL = WM_USER + 1;

type

  TForm16 = class(TForm)
    RichViewEdit1: TRichViewEdit;
    RVStyle1: TRVStyle;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure RichViewEdit1RVMouseDown(Sender: TCustomRichView;
      Button: TMouseButton; Shift: TShiftState; ItemNo, X, Y: Integer);
  private
    { Private declarations }
    procedure Highlight(memo: TCustomRichViewEdit; silent: Boolean);
    procedure WMHighlightCell(var Msg: TMessage); message WM_HIGHLIGHTCELL;
  public
    { Public declarations }
  end;

var
  Form16: TForm16;

implementation

{$R *.dfm}

procedure TForm16.Button1Click(Sender: TObject);
begin
  Highlight(RichViewEdit1, False);
end;

procedure TForm16.FormCreate(Sender: TObject);
var
 Table: TRVTableItemInfo;
begin
  RichViewEdit1.Clear;
  Table := TRVTableItemInfo.CreateEx(5, 5, RichViewEdit1.RVData);
  Table.BorderWidth := 1;
  Table.CellBorderWidth := 1;
  RichViewEdit1.AddItem('', Table);
  RichViewEdit1.Format;
end;



procedure TForm16.Highlight(memo: TCustomRichViewEdit; silent: Boolean);
var i, j: integer;
  cs, rs, itemNo, Data: integer; // Color the entire font background
  rveTzeile1, rveTspalte1: Integer;
  rve: TCustomRichViewEdit;
  rveTable: TRVTableItemInfo;
  hFarbe: TColor;

begin
  // Does table have the cursor?
  if (not memo.CanChange) or
   not memo.GetCurrentItemEx (TRVTableItemInfo, rve, TCustomRVItemInfo (rveTable)) then
   begin
     if not silent then
       ShowMessage ('This option is intended to provide better orientation in a table,' + #10 +
        'by using the focused line u. Column turns yellow (discolored). '+ #10);
     exit;
   end;

   cs  := - 1; rs := - 1;
   if not rveTable.GetNormalizedSelectionBounds (true, rveTzeile1, rveTspalte1,
     CS, RS) then
      exit;
   if (cs <> 1) or (rs <> 1) then
      exit;

  ItemNo := rveTable.GetMyItemNo;
  memo.BeginUndoGroup (rvutModifyItem);
  memo.SetUndoGroupMode (True);
  memo.BeginItemModify (ItemNo, Data);
  try
    // Determine the focused line here


    // Determine the focused cell color
    hFarbe := rveTable.cells [rveTzeile1, rveTspalte1] .color;
    if hFarbe <> 11993087 then
      hFarbe := 11993087
    else
      hFarbe := clWhite;
    // Color all cells in the table white
    for j := 0 to rveTable.RowCount-1 do
      for i := 0 to rveTable.ColCount-1 do
        if rveTable.Cells[j, i] <> nil then
          rveTable.SetCellColor (clWhite, j, i);
    // Color focused cells in a row
    for j := 0 to rveTable.ColCount-1 do
      if rveTable.Cells[rveTzeile1, j] <> nil then
       rveTable.SetCellColor (hFarbe, rveTzeile1, j);
    // Color focused cells in a column
    for j := 0 to rveTable.RowCount-1 do
      if rveTable.Cells[j, rveTspalte1] <> nil then
        rveTable.SetCellColor (hFarbe, j, rveTspalte1);
  finally
    memo.EndItemModify (ItemNo, Data);
    memo.SetUndoGroupMode (False);
    memo.Change;
    if memo.GetCurrentItemEx (TRVTableItemInfo, rve, TCustomRVItemInfo (rveTable)) then
      rveTable.EditCell (rveTzeile1, rveTspalte1);
  end;
end;

procedure TForm16.RichViewEdit1RVMouseDown(Sender: TCustomRichView;
  Button: TMouseButton; Shift: TShiftState; ItemNo, X, Y: Integer);
begin
  // We cannot call Highlight() in this event, because it may destroy the
  // current cell inplace editor.
  // So we use PostMessage to call it later in WMHighlightCell()
  if (Button = mbLeft) and (ssDouble in Shift) then
    PostMessage(Handle, WM_HIGHLIGHTCELL, 0, 0);
end;

procedure TForm16.WMHighlightCell(var Msg: TMessage);
begin
  Highlight(RichViewEdit1, True);
end;



end.
